#include "arrays.h"

const std::unordered_map<int, std::string> Arrays::kKeyNames {
    { VK_LBUTTON, "Left Mouse Button" },
    { VK_RBUTTON, "Right Mouse Button" },
    { VK_CANCEL, "Cancel" },
    { VK_MBUTTON, "Middle Mouse Button" },
#if(_WIN32_WINNT >= 0x0500)
    { VK_XBUTTON1, "Mouse Button 4" },
    { VK_XBUTTON2, "Mouse Button 5" },
#endif  // _WIN32_WINNT >= 0x0500

    { VK_BACK, "Back" },
    { VK_TAB, "Tab" },

    { VK_CLEAR, "Clear" },
    { VK_RETURN, "Enter" },

    { VK_SHIFT, "Shift" },
    { VK_CONTROL, "Ctrl" },
    { VK_MENU, "Menu" },
    { VK_PAUSE, "Pause" },
    { VK_CAPITAL, "Caps" },

    { VK_ESCAPE, "Escape" },

    { VK_SPACE, "Space" },
    { VK_PRIOR, "Prior" },
    { VK_NEXT, "Next" },
    { VK_END, "End" },
    { VK_HOME, "Home" },
    { VK_LEFT, "Left Arrow" },
    { VK_UP, "Up Arrow" },
    { VK_RIGHT, "Right Arrow" },
    { VK_DOWN, "Down Arrow" },
    { VK_SELECT, "Select" },
    { VK_PRINT, "Print" },
    { VK_EXECUTE, "Execute" },
    { VK_SNAPSHOT, "Snapshot" },
    { VK_INSERT, "Insert" },
    { VK_DELETE, "Delete" },
    { VK_HELP, "Help" },

    { 0x30, "Key 0" },
    { 0x31, "Key 1" },
    { 0x32, "Key 2" },
    { 0x33, "Key 3" },
    { 0x34, "Key 4" },
    { 0x35, "Key 5" },
    { 0x36, "Key 6" },
    { 0x37, "Key 7" },
    { 0x38, "Key 8" },
    { 0x39, "Key 9" },

    { 0x41, "Key A" },
    { 0x42, "Key B" },
    { 0x43, "Key C" },
    { 0x44, "Key D" },
    { 0x45, "Key E" },
    { 0x46, "Key F" },
    { 0x47, "Key G" },
    { 0x48, "Key H" },
    { 0x49, "Key I" },
    { 0x4A, "Key J" },
    { 0x4B, "Key K" },
    { 0x4C, "Key L" },
    { 0x4D, "Key M" },
    { 0x4E, "Key N" },
    { 0x4F, "Key O" },
    { 0x50, "Key P" },
    { 0x51, "Key Q" },
    { 0x52, "Key R" },
    { 0x53, "Key S" },
    { 0x54, "Key T" },
    { 0x55, "Key U" },
    { 0x56, "Key V" },
    { 0x57, "Key W" },
    { 0x58, "Key X" },
    { 0x59, "Key Y" },
    { 0x5A, "Key Z" },

    { VK_LWIN, "Left Windows Button" },
    { VK_RWIN, "Right Windows Button" },
    { VK_APPS, "Apps" },

    { VK_SLEEP, "Sleep" },

    { VK_NUMPAD0, "Numpad 0" },
    { VK_NUMPAD1, "Numpad 1" },
    { VK_NUMPAD2, "Numpad 2" },
    { VK_NUMPAD3, "Numpad 3" },
    { VK_NUMPAD4, "Numpad 4" },
    { VK_NUMPAD5, "Numpad 5" },
    { VK_NUMPAD6, "Numpad 6" },
    { VK_NUMPAD7, "Numpad 7" },
    { VK_NUMPAD8, "Numpad 8" },
    { VK_NUMPAD9, "Numpad 9" },

    { VK_MULTIPLY, "Numpad Multiply" },
    { VK_ADD, "Numpad Add" },
    { VK_SEPARATOR, "Numpad Separator" },
    { VK_SUBTRACT, "Numpad Subtract" },
    { VK_DECIMAL, "Numpad Decimal" },
    { VK_DIVIDE, "Numpad Divide" },

    { VK_F1, "F1" },
    { VK_F2, "F2" },
    { VK_F3, "F3" },
    { VK_F4, "F4" },
    { VK_F5, "F5" },
    { VK_F6, "F6" },
    { VK_F7, "F7" },
    { VK_F8, "F8" },
    { VK_F9, "F9" },
    { VK_F10, "F10" },
    { VK_F11, "F11" },
    { VK_F12, "F12" },

    { VK_NUMLOCK, "Num Lock" },
    { VK_SCROLL, "Scroll" },

    { VK_OEM_NEC_EQUAL, "Numpad =" },

    { VK_LSHIFT, "Left Shift" },
    { VK_RSHIFT, "Right Shift" },
    { VK_LCONTROL, "Left Ctrl" },
    { VK_RCONTROL, "Right Ctrl" },
    { VK_LMENU, "Left Menu" },
    { VK_RMENU, "Right Menu" }
};
